package de.doggoat.growableRebalance.listeners;
import de.doggoat.growableRebalance.PlantUtils;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.BlockState;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.world.StructureGrowEvent;
import org.bukkit.plugin.java.JavaPlugin;

import java.lang.reflect.Array;
import java.util.logging.Logger;
import java.util.Arrays;
import java.util.List;

public class GrowthEventListener implements Listener {

    List<Material> dirtBlocks = Arrays.asList(Material.ROOTED_DIRT, Material.PODZOL);
    List<Material> unreplaceableBlocks = Arrays.asList(Material.MOSS_BLOCK, Material.MUD, Material.MUDDY_MANGROVE_ROOTS);
    JavaPlugin plugin;
    Logger log;

    public GrowthEventListener(JavaPlugin plugin) {
        this.plugin = plugin;
        log = plugin.getLogger();
    }

    @EventHandler
    public void onStructureGrow(StructureGrowEvent e) {
        Player p = e.getPlayer();
        Location ground = PlantUtils.getSingleBlockGround(e.getLocation());

        if (unreplaceableBlocks.contains(ground.getBlock().getType())) {
            e.setCancelled(true);
            if (p != null) {
                p.sendMessage("You cannot grow " + e.getLocation().getBlock().getType() + " on " + ground.getBlock().getType());
            }
            return;
        }

        List<BlockState> forbiddenBlocks = e.getBlocks().stream()
                .filter(blockState -> unreplaceableBlocks.contains(blockState.getBlock().getType()))
                .filter(blockState -> dirtBlocks.contains(blockState.getType()))
                .toList();

        if (!forbiddenBlocks.isEmpty()) {
            if (p != null) {
                BlockState forbiddenBlockState = forbiddenBlocks.getFirst();
                p.sendMessage("You cannot convert " + forbiddenBlockState.getBlock().getType().name() + " to " + forbiddenBlockState.getType().name());
            }
            e.setCancelled(true);
        }
    }

}
